import 'package:flutter/material.dart';
import 'dart:async';
import 'package:sql_query/database_model.dart';
import 'package:sql_query/sql_query.dart';
import 'package:sql_query_example/testing.dart';

void main() {
  runApp(const MyApp());
}

class MyApp extends StatefulWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  State<MyApp> createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  void initState() {
    super.initState();

    Future.delayed(Duration.zero, () async {
      await DB.init(
        databaseName: 'testing',
        tableList: [
          TableDatabase(
            tableName: 'user',
            column: [
              ColumnDatabase(
                name: 'id',
                typeData: DataType.integer,
                primaryKey: true,
                autoIncrement: true,
              ),
              ColumnDatabase(
                name: 'name',
                typeData: DataType.text,
              ),
            ],
          ),
          TableDatabase(
            tableName: 'sales',
            column: [
              ColumnDatabase(
                name: 'id',
                typeData: DataType.integer,
                primaryKey: true,
                autoIncrement: true,
              ),
              ColumnDatabase(
                name: 'userId',
                typeData: DataType.integer,
              ),
              ColumnDatabase(
                name: 'price',
                typeData: DataType.double,
              ),
            ],
          ),
          TableDatabase(
            tableName: 'product',
            column: [
              ColumnDatabase(
                name: 'id',
                typeData: DataType.integer,
                primaryKey: true,
                autoIncrement: true,
              ),
              ColumnDatabase(
                name: 'salesId',
                typeData: DataType.integer,
              ),
              ColumnDatabase(
                name: 'userId',
                typeData: DataType.integer,
              ),
              ColumnDatabase(
                name: 'count',
                typeData: DataType.double,
              ),
            ],
          ),
        ],
      );
    });

    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {}

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Testing(),
    );
  }
}
