import 'package:sql_query/on_going/query.dart';

import '../database_config.dart';
import '../database_model.dart';

class DB {
  static Query table(String table) {
    return Query(
      table: table,
    );
  }

  static init({required List<TableDatabase> tableList, String? databaseName}) async {
    List<String> insertList = [];
    for (final tl in tableList) {
      String insert = 'CREATE TABLE ${tl.tableName} (';
      int total = 0;
      for (final tc in tl.column) {
        ++total;
        String prop = '';

        if (tc.typeData == DataType.text) {
          prop += ' TEXT';
        } else if (tc.typeData == DataType.integer) {
          // if (tc.typeData == DataType.bool) {
          //   _boolData.add(tc.name);
          // }
          prop += ' INTEGER';
        } else if (tc.typeData == DataType.double) {
          prop += ' REAL';
        }

        if (tc.primaryKey) {
          prop += ' PRIMARY KEY';
        }

        if (tc.autoIncrement) {
          prop += ' AUTOINCREMENT';
        }

        if (tc.isNull) {
          prop += ' NULL';
        }

        insert += '${tc.name} ' + prop;
        if (tl.column.length > 1 && total != tl.column.length) {
          insert += ', ';
        }
      }
      insert += ')';
      insertList.add(insert);
    }
    await DatabaseConfig.init(tables: insertList, dbName: databaseName);
  }

  static deleteDB() {
    DatabaseConfig.dbDelete();
  }

  static closeDB() {
    DatabaseConfig.dbClose();
  }
}
